## freefem++ 3.26-2

=== debian/changelog ===
freefem++ (3.26-2-3) unstable; urgency=low

  * Change package urgency from medium to low

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Thu, 26 Dec 2013 19:30:00 +0200

freefem++ (3.26-2-2) unstable; urgency=medium

  [ Dimitrios Eftaxiopoulos ]
  * Enable build with metis

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Thu, 26 Dec 2013 16:13:46 +0200

freefem++ (3.26-2-1) unstable; urgency=low

  * Imported Upstream version 3.26-2 (Closes: #706714)
  * Disable make check execution in d/rules (Closes: #730739)
  * Correct architecture names for hurd and kfreebsd (Closes: #730738)
  * Make libmesh.a install only in libfreefem++ binary
  * Fix duplication of executables (Closes: #701161)
  * Update standards version
  * Set installation dir of WHERE* scripts to /usr/include/freefem++
  * Add rdfind and symlinks to build deps in d/control

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Thu, 19 Dec 2013 22:38:49 +0200

freefem++ (3.25-1) unstable; urgency=low

  [ Dimitrios Eftaxiopoulos ]
  * Imported Upstream version 3.25 (Closes: #701161 #706714)
  * Change installation directory of header-like *.idp files
    from /usr/lib/freefem++ to /usr/include/freefem++, in order
    to fix a lintian warning
  * Update patch to examples++-load/Makefile.am in order to enable
    functioning of load *.so and include *.idp commands in *.edp
    scripts
  * Delete patches to src/Graphics/sansgraph.cpp and
    src/Graphics/xglrgraph.cpp because they are not needed any more
  * Fix lintian warning about missing LDFLAGS
  * Override dh_auto_test in debian/rules, such that in case it is 
    used, it completes executing all *.edp example files, regardless
    of aborting on some of them
  * Add libmetis-dev to build-deps in d/control
  * Remove libparmetis-dev from build deps
  * Add --parallel option to dh $@ in debian/rules
  * Add hardening compilation flags to mpic++
  * Allow testing of compiling and running the example files after build

  [ Christophe Trophime ]
  * update C. Trophime email
  * add support for nlopt, ipopt - simplify debian/rules
  * upload CT changes to 3.20
  * add patch for configure
  * add patch for examples++-mpi
  * fix bamg install
  * add corrected scripts to build plugins
  * add patch for properly build examples++-load
  * add lintian overrides for libfreefem++
  * add some missing files
  * update patches
  * update rules
  * reorder BuildDepends - comment out unsupported libs

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Thu, 12 Sep 2013 00:02:58 +0300

=== debian/control ===
Source: freefem++
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>, 
 Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>
Build-Depends: debhelper (>= 9~), dh-autoreconf,
 quilt, gawk, gfortran, rdfind, symlinks,
 flex, bison, libxt-dev, libxext-dev, libxxf86vm-dev, 
 libxpm-dev, libmumps-scotch-dev, libmumps-ptscotch-dev,
 libfltk1.3-dev | libfltk-dev, freeglut3-dev, ghostscript, imagemagick,
 texlive, texlive-extra-utils, texlive-latex-extra, texlive-font-utils, 
 libfftw3-dev, libblas-dev, libgsl0-dev,
 libhypre-dev, 
 libarpack2-dev, libsuitesparse-dev,
 libmumps-dev, libblacs-mpi-dev, libscalapack-mpi-dev,
 libscotch-dev, libptscotch-dev,
 libmetis-dev,
 libmumps-seq-dev, 
 libnlopt-dev, 
 coinor-libipopt-dev,
 libgmm++-dev
# libtet1.4-dev,
# libmmg3dlib4.0-4.0-dev, freeyams, mshmet, mshint,
# libparms2-dev, libitsol-dev,
# libhips-dev, libpastix-dev,
# libsuperlu-dist-dev
## libsuperlu4-dev 
Standards-Version: 3.9.5
Homepage: http://www.freefem.org/ff++/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/freefempp.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/freefempp.git

Package: freefem++
Architecture: any
Section: math
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Provides the binaries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the executables of FreeFem++.

Package: libfreefem++
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Provides the shared libraries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the shared libraries of FreeFem++.

Package: libfreefem++-dev
Architecture: any
Section: libdevel
Depends: libfreefem++, ${shlibs:Depends}, ${misc:Depends}
Description: Provides the development files of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the development files of FreeFem++.

Package: freefem++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Provides the documentation of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve. 
 .
 This package contains the documentation files of FreeFem++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v

# export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)


%:
	dh $@ --with autoreconf --parallel

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
# 
# # to avoid lintian warnings
# CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
# CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
# CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
# LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
# 
 override_dh_auto_clean:
	dh_auto_clean
	rm -f config.log
	rm -f config-version.h config_LIB_INFO configure.param
	rm -f download/fftw/cxxflags
	rm -f download/hips/config.log download/ipopt/config.log
	rm -f download/metis/config.log download/metis/Makefile.in
	rm -f download/mumps/config.log download/mumps-seq/config.log
	rm -f download/parmetis/config.log
	rm -f download/parms/config.log download/parms/Makefile.in
	rm -f download/pastix/config-complex.in download/pastix/config.log
	rm -f download/scalapack/config.log
	rm -f download/scotch/config.log
	rm -f download/superludist/config.log
	rm -f download/tetgen/cxxflags
	cd src && rm -f medit/compil.date mpi/config.log mpi/ff-mpirun \
			lglib/lg.output
	cd DOC && rm -f cpfigs/*.pdf addfe.aux freefem++doc.aux \
			freefem++doc.idx freefem++doc.ilg freefem++doc.ind \
			freefem++doc.log freefem++doc.out \
			freefem++doc.pdfsync freefem++doc.toc
	cd examples++-load && rm -f *.ps *.txt *.mesh glu2D.mesh.gmsh \
					pippo.data pippo.dx triQA.msh \
					freefem++.pref config.log \
					WHERE_LIBRARY-config ipopt.out
	cd examples++-tutorial && rm -f A.matrix *.ps *.txt g.mesh toto.Th \
					*.gmsh toto.am_fmt toto.dbg lestables \
					freefem++.pref Th*.msh emptymesh-2.msh \
					th.msh toto.msh
	rm -f examples++/toto.txt
	cd examples++-3d && rm -f A.txt B.txt Th.mesh Th3.mesh dd.bb dd.meshb \
					freefem++.pref
	cd examples++-chapt3 && rm -f J.txt Th.mesh Th.msh graph.txt *.ps
	cd examples++-mpi && rm -f beam-deformed-mumps.mesh *.ps \
				   freefem++.pref *.so *.o

# #
# # To rebuild
# 	find . -name \*.o | xargs --no-run-if-empty rm
# 	find . -name \*.so | xargs --no-run-if-empty rm
#
 
override_dh_autoreconf_clean:
	dh_autoreconf_clean
	dh_quilt_unpatch

override_dh_autoreconf:
	dh_quilt_patch
	dh_autoreconf --as-needed

 override_dh_auto_configure:
	dh_auto_configure -- CC="gcc $(LDFLAGS)" CXX="g++ $(LDFLAGS)" MPICXX="mpic++ $(LDFLAGS)"
# 	   CPPFLAGS=$(CPPFLAGS) \
# 	   CFLAGS="$(CFLAGS) -lm" \
# 	   CXXFLAGS="$(CXXFLAGS)" \
# 	   CXX=mpic++
# 	cp -f examples++-load/WHERE_LIBRARY-config debian
# 	dh_auto_build
 
override_dh_auto_install:
	dh_auto_install
	mv debian/tmp/usr/bin/bamg debian/tmp/usr/bin/ffbamg
	rdfind -outputname debian/results.txt -makesymlinks true debian/tmp/usr/bin/
	symlinks -r -s -c debian/tmp/usr/bin/

# #
# # Install modified script to create plugins	
# 	cp examples++-load/WHERE_LIBRARY-config examples++-load/WHERE_LIBRARY
# 	cp -f debian/ff-c++ debian/tmp/usr/bin
# 	cp -f debian/ff-get-dep debian/tmp/usr/bin
# #
# # Fix lintian warnings
# 	chmod ugo-x debian/tmp/usr/lib/ff++/3.*/idp/*.idp
# 
 
 override_dh_auto_test:
#	$(MAKE) $(AM_MAKEFLAGS) -i check

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
#http://www.freefem.org/ff++/ftp/ freefem\+\+-(.*)\.tar\.gz
opts=uversionmangle=s/-([^-]+)/.$1/,dversionmangle=s/\.dfsg$// \
  http://www.freefem.org/ff++/ftp/ freefem\+\+-([\d.-]+)\.tar\.gz

## freefem++ 3.31

=== download/ipopt/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.inc

all-local: Ipopt

# Downloading and compiling mumps
# ------------------------------

DIR=$(DOWNLOADFF)/ipopt
DIRPKG=../pkg
SRCDIR=Ipopt-$(VERSION)
PACKAGE=$(DIRPKG)/Ipopt-$(VERSION).tgz
INSTALL=../..
VERSION=3.10.2
# 3.10.2
URL=http://www.coin-or.org/download/source/Ipopt
FHSL=#$(DIRPKG)/ddeps.f $(DIRPKG)/ma27ad.f  $(DIRPKG)/mc19d.f 
LIBMUMPS=-L$(DOWNLOADFF)/lib  -ldmumpsFREEFEM-SEQ -lzmumpsFREEFEM-SEQ -lmumps_commonFREEFEM-SEQ -lpordFREEFEM-SEQ -lmpiseqFREEFEM-SEQ
INCMUMPS=$(DOWNLOADFF)/include/libseq 
#/Ipopt-3.10.2.tgz
Ipopt: $(SRCDIR)/FAIRE
#  --enable-static  --disable-shared  

# ALH - 6/1/14 - We need to specify FLIBS explicitely because Ipopt
# fails to guess FLIBS correctly on Windows+Cygwin+Mingw64, see [[file:Makefile.inc.in::FLIBS]]

$(SRCDIR)/FAIT: $(SRCDIR)/tag-tar
#	FFCS - disable dependency tracking like in FFCS itself for MinGW compilation (problem with backslashes, see
#	[[file:../../../../configure.ac::enable_dependency_tracking]])
	cd $(SRCDIR) ; \
	 ./configure --disable-dependency-tracking \
		   --disable-shared --enable-static \
                  --with-mumps='$(LIBMUMPS)' \
	          --without-hsl \
	          --with-mumps-incdir='$(INCMUMPS)' \
	  CXX='$(CXX)' CXXFLAGS='$(CXXFLAGS) -I$(INCMUMPS)' \
	  CC='$(CC)' CFLAGS='$(CFLAGS) -I$(INCMUMPS)' \
	  F77='$(FC)' FFLAGS='$(FCFLAGS)' \
	  FLIBS='$(FLIBS)' \
	  CXXCPP='$(CXXCPP)'  CPP='$(CXXCPP)' \
	 --with-blas='$(LIBBLAS)' --with-lapack='$(LIBLAPACK)' --prefix='$(DOWNLOADFF)'
	touch $(SRCDIR)/FAIT	

# FFCS - avoid remaking install every time
install.done: $(SRCDIR)/FAIT
	$(MAKE)  -C  $(SRCDIR) install	
	touch $@
clean-local::
	-rm *.done

# FFCS - install and WHERE need to be sequential
WHERE.done: install.done
	echo Ipopt LD -L@DIR@/lib   -lipopt   >$(SRCDIR)/$(INSTALL)/lib/WHERE.Ipopt;
	echo Ipopt INCLUDE -I@DIR@/include/coin  >> $(SRCDIR)/$(INSTALL)/lib/WHERE.Ipopt ;
	touch $@

Makefile.inc:
	../../config.status  --file="Makefile.inc:Makefile.inc.in"

# FFCS - install and WHERE need to be sequential
$(SRCDIR)/FAIRE: install.done WHERE.done
	touch $@


$(SRCDIR)/$(INSTALL): $(SRCDIR)/tag-tar

$(SRCDIR)/tag-tar:$(PACKAGE) $(FHSL) 
	tar xvzf $(PACKAGE)
	patch -p0 <patch-IpBlas
	touch $(SRCDIR)/tag-tar

$(PACKAGE):
	../getall -o Ipopt -a

clean-local::
	rm -rf  $(SRCDIR)  *~ Makefile.inc

clean: clean-local
	-rm -rf ../include/coin
	-rm ../lib/libipopt* ../lib/liblcoinhsl* 
	-rm $(PACKAGE)

.PHONY:$(SRCDIR)/$(INSTALL)

=== download/metis/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.in

all-local: metis

# Downloading and compiling Tetgen
# ------------------------------
# http://glaros.dtc.umn.edu/gkhome/fetch/sw/metis/metis-4.0.tar.gz
# Metis information
DIRPKG=../pkg
SRCDIR=metis-$(metis_VERSION)
PACKAGE=$(DIRPKG)/metis-$(metis_VERSION).tar.gz
SERVER=http://www.netlib.org/linalg/
#//http://glaros.dtc.umn.edu/gkhome/fetch/sw/metis/OLD
INSTALL=../..

# FFCS - 14/11/11 - version 4.0.3 is not available from netlib anymore
metis_VERSION=4.0

metis: FAIRE


$(SRCDIR)/FAIT:
	$(MAKE) install
	touch $(SRCDIR)/FAIT

install:$(SRCDIR)/tag-compile
	cd $(SRCDIR)/Programs ;$(MAKE) 
	-mkdir -p ../include/metis
	cp $(SRCDIR)/Lib/*.h ../include/metis


FAIRE: $(SRCDIR)/FAIT 
	$(MAKE) WHERE
	touch FAIRE

Makefile.in: ../../config.status Makefile-metis.in
	../../config.status  --file="Makefile.in:Makefile-metis.in"

$(SRCDIR)/tag-compile: $(SRCDIR)/tags
	cp Makefile.in $(SRCDIR)
	-mkdir -p ../lib/metis
	cd $(SRCDIR)/Lib;make
	-cd $(SRCDIR)/Programs;make 
	touch $(SRCDIR)/tag-compile



WHERE: 
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	echo metis LD -L@DIR@/lib/metis -lmetis  >$(SRCDIR)/$(INSTALL)/lib/WHERE.metis ;\
	echo metis INCLUDE -I@DIR@/include/metis>> $(SRCDIR)/$(INSTALL)/lib/WHERE.metis ;\
	fi




# FFCS: patch is necessary for metis 4.0, but not for 4.0.3
$(SRCDIR)/tags: $(PACKAGE)
	tar xvzf $(PACKAGE)
	patch -p0  <patch-metis
	patch -p0  <metis-4.0_main_return.patch
	mv  $(SRCDIR)/Programs/Makefile $(SRCDIR)/Programs/Makefile-orig
	sed -e 's;BINDIR = ..;BINDIR = ../$(INSTALL)/bin;' \
            -e 's;../libmetis.a;../$(INSTALL)/lib/metis/libmetis.a;' \
            -e 's;-L[.][.];-L../$(INSTALL)/lib/metis;' \
          <$(SRCDIR)/Programs/Makefile-orig \
          >$(SRCDIR)/Programs/Makefile
	mv $(SRCDIR)/Lib/Makefile $(SRCDIR)/Lib/Makefile-orig
	sed   -e 's;../libmetis.a;../$(INSTALL)/lib/metis/libmetis.a;' \
          <$(SRCDIR)/Lib/Makefile-orig \
          >$(SRCDIR)/Lib/Makefile
	touch $(SRCDIR)/tags

$(PACKAGE):
	../getall -o METIS -a

clean-local:
	-cd $(SRCDIR) && $(MAKE) realclean  -C $(SRCDIR)
	-rm -rf metis-4.0 config.log
	-rm -rf ../lib/metis ../lib/WHERE.metis
	-rm -rf ../include/metis
	-rm -rf $(SRCDIR)
	-rm FAIRE FAIT 

# FFCS - 23/5/12 - $(SRCDIR)/$(INSTALL) is meaningless if $(SRCDIR) does not exist
clean: clean-local
	-rm ../lib/metis/libmetis.a
	-rm ../lib/include/metis.h
	-rm -rf $(SRCDIR)
	-rm FAIRE FAIT

=== download/mmg3d/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: mmg3d

include ff-flags

# Downloading and compiling mmg3d
# -------------------------------
# 
DIRPKG= ../pkg
SRCDIR= ./mmg3d4
PACKAGE=$(DIRPKG)/mmg3d4.0.tgz
INSTALL=..
mmg3d_VERSION=
# mmg3d pas sur internet
LIBMMG3D=$(INSTALL)/lib/libmmg3d-v4.a
OPT=4
# size of the PKG file ( this file change See Cecile.) FFCS - 19/2/13 - the test for the file size (`stat -f "%z" file`)
# is not portable from MacOS, so just leave it out in FFCS (SIZEPKG is still useful to force a remake when the package
# changes)
SIZEPKG=158547

OBJS= analar.o	chkmsh.o	hash.o		memory.o	optcte.o	outqua.o	simu44.o	swap44.o	zaldy.o \
analarcutting.o	chrono.o	heap.o		mmg3d1.o	optlap.o	pattern.o	simu56.o	swap56.o \
baryct.o	colpoi.o	inout.o		mmg3d4.o	optlen.o	quality.o	simu68.o	swap68.o \
boulep.o	coquil.o	length.o	mmg3d9.o	optlentet.o	queue.o		simu710.o	swap710.o \
bucket.o	cutelt.o	librnbg.o	movevertex.o	optra4.o	ratio.o		solmap.o	swapar.o \
		delaunay.o	locate.o	optbdry.o	opttet.o	scalem.o	spledg.o	swaptet.o \
cenrad.o	eigenv.o	matrix.o	optcoq.o	opttyp.o	simu23.o	swap23.o	typelt.o 

OBJSNOP =  cendel.o swapar.o

# FFCS - simplify Makefile structure
mmg3d:WHERE.done

mmg3d4/FAIT-4.done:tag-tar-$(SIZEPKG)
	echo "#define COMPIL " '"' `date` '"' > ./mmg3d4/build/sources/compil.date
	cd mmg3d4/build/sources/; $(MAKE) CC='$(CC)' CFLAGS='$(CNOFLAGS) -g'   $(OBJSNOP) 
	cd mmg3d4/build/sources/; $(MAKE) CC='$(CC)' CFLAGS='$(CFLAGS) -g'   $(OBJS) 
	cd mmg3d4/build/sources/mmg3dmain; $(CC) -c $(CFLAGS)   mmg3d.c -I..
	$(AR) $(ARFLAGS) $(LIBMMG3D) mmg3d4/build/sources/*.o mmg3d4/build/sources/mmg3dmain/mmg3d.o
#
#	FFCS - ranlib required on Windows 7 64 bits
#
	$(RANLIB) $(LIBMMG3D)
	-$(CC) $(CNOFLAGS) mmg3d4/build/sources/mmg3dmain/mmg3d.o   mmg3d4/build/sources/*.o -o ../bin/mmg3d $(STD_LIBS)
	touch mmg3d4/FAIT-4.done

# FFCS - simplify Makefile structure
install-4.done:mmg3d4/FAIT-4.done 
	-mkdir ../include/mmg3d-v4/		
	cp mmg3d4/build/sources/*.h ../include/mmg3d-v4/
	touch $@
clean::
	-rm install-4.done

mmg3d-4:$(PACKAGE)

install:install-4.done WHERE.done

# FFCS - keep simplest makefile structure for automatic recompilations
WHERE.done: install-4.done
	echo mmg3d-v4  LD -L@DIR@/lib -lmmg3d-v4  >../lib/WHERE.mmg3d ;
	echo mmg3d-v4 INCLUDE -I@DIR@/include/mmg3d-v4>> ../lib/WHERE.mmg3d ;
	echo build WHERE ./lib/WHERE.mmg3d ;
	touch $@
clean::
	-rm WHERE.done

FAIRE: mmg3d4/FAIT-4.done install-4.done

# FFCS - keep it simple
tag-tar-$(SIZEPKG): $(PACKAGE) patch-mmg3dv4.diff
	-rm -rf  mmg3d4
	tar xvzf $(PACKAGE)
	touch mmg3d4/build/sources/dataff.h 	
#
#	ALH - clean-up all CR/LF to make patching more successful
#
	../../build/cleancrlf mmg3d4
#
	cd mmg3d4;patch -p1 <../patch-mmg3dv4.diff
	cat </dev/null >mmg3d4/build/sources/mmg3dConfig.h
	touch tag-tar-$(SIZEPKG)
#	cp makefile-mmg3d.inc $(SRCDIR)/makefile

$(PACKAGE):
	../getall -o MMG3D -a

clean::
	-rm ff-flags
#
#	FFCS - make sure that all directories are cleaned. Thisis especially important under Windows because there is no
#	compilation dependencies control there (see
#	[[file:c:/cygwin/home/alh/ffcs/dist/configure.ac::dependency_tracking]])
#
	-rm -r mmg3d4
	-rm FAIT* mmg* flags-* tag-tar*
	-rm $(PACKAGE)

ff-flags: ../Makefile Makefile
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'STD_LIBS *=' ../Makefile >> ff-flags
	grep 'CNOFLAGS *=' ../Makefile >> ff-flags
.PHONY:$(SRCDIR)/$(INSTALL)

=== download/mumps-seq/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
# 
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
# 
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.inc

all-local: mumps
mumps:../lib/WHERE.mumpsseq

# Downloading and compiling mumps
# -------------------------------

DIRPKG=../pkg
SRCDIR=MUMPS_$(VERSION)
PACKAGE1=$(DIRPKG)/MUMPS_$(VERSION).tar.gz
INSTALL=../..
VERSION=4.10.0

# FFCS - install and WHERE need to be done sequentially, even in parallel builds

../lib/WHERE.mumpsseq: install.done
	echo mumps-seq LD -L@DIR@/lib -ldmumpsFREEFEM-SEQ -lzmumpsFREEFEM-SEQ -lmumps_commonFREEFEM-SEQ	\
		-lpordFREEFEM-SEQ $(LIBSPTHREAD)  > ../lib/WHERE.mumpsseq
	echo mumps-seq INCLUDE -I@DIR@/include/libseq >> ../lib/WHERE.mumpsseq
	echo libseq LD -L@DIR@/lib  -lmpiseqFREEFEM-SEQ >>../lib/WHERE.mumpsseq
	echo libseq INCLUDE -I@DIR@/include/libseq >> ../lib/WHERE.mumpsseq

install.done: $(SRCDIR)/FAIT
	-mkdir -p ../include/libseq
	cp $(SRCDIR)/include/*.h ../include/libseq
	cp $(SRCDIR)/libseq/*.h  ../include/libseq
	-mkdir -p ../lib
	cp $(SRCDIR)/lib/*.a ../lib/
	cp $(SRCDIR)/libseq/libmpiseqFREEFEM-SEQ.a ../lib/
	touch $@

$(SRCDIR)/FAIT:Makefile.inc
	cp Makefile.inc $(SRCDIR)
#
#	FFCS - 22/5/12 - Mumps has difficulties compiling d & z in parallel
#
	cd $(SRCDIR) && $(MAKE) d
	cd $(SRCDIR) && $(MAKE) z
	touch $@

Makefile.inc: ../../config.status Makefile Makefile-mumps-$(VERSION).inc $(SRCDIR)/tag-tar
	../../config.status  --file="Makefile.inc:Makefile-mumps-$(VERSION).inc"

$(SRCDIR)/tag-tar:$(PACKAGE1)
	tar xvzf $(PACKAGE1)
	touch $@

$(PACKAGE1):
	../getall -o MUMPS -a

clean:
	-rm Makefile.inc FAIRE* *~ 
	-rm -rf ../include/*mumps*
	-rm -rf ../lib/lib*mumps* ../lib/libpord*.a ../lib/libmpiseq*.a ../lib/WHERE.mumpsseq
	-rm -rf $(SRCDIR)
	-rm *.done config.log

# Local Variables:
# mode:makefile
# ispell-local-dictionary:"british"
# coding:utf-8
# End:

=== download/mumps/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
# 
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
# 
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

include Makefile.inc

all-local: mumps

# Downloading and compiling mumps
# -------------------------------

DIRPKG=../pkg
SRCDIR=MUMPS_$(VERSION)
PACKAGE1=$(DIRPKG)/MUMPS_$(VERSION).tar.gz
VERSION=4.10.0

mumps:../lib/WHERE.mumps

$(SRCDIR)/FAIT: $(SRCDIR)/tag-tar
	cp Makefile.inc $(SRCDIR)
#
# ALH - 'd' and 'z' versions need to be made sequentially
#
	cd $(SRCDIR);make d
	cd $(SRCDIR);make z
	touch $@

# ALH - WHERE was not built properly during a full compile from a clean source. This goal has been rewritten to solve
# this issue.

../lib/WHERE.mumps:install.done
	echo mumps LD -L@DIR@/lib   -ldmumpsFREEFEM -lzmumpsFREEFEM  -lmumps_commonFREEFEM -lpordFREEFEM -lpthread  > $@
	echo mumps INCLUDE -I@DIR@/include  >> $@

install.done:$(SRCDIR)/FAIT
	-mkdir -p ../include/libseq
	cp $(SRCDIR)/include/*.h ../include/
	cp $(SRCDIR)/libseq/*.h  ../include/libseq
	-mkdir -p ../lib
	cp $(SRCDIR)/lib/*.a ../lib/
	cp $(SRCDIR)/libseq/libmpiseqFREEFEM.a ../lib/
	touch $@

FAIRE-$(VERSION):WHERE
	touch FAIRE-$(VERSION)

# ALH - "make d" and "make z" need to be done sequentially
$(SRCDIR)/FAIT:$(SRCDIR)/tag-tar Makefile.inc
	cp Makefile.inc $(SRCDIR)
	cd $(SRCDIR) && $(MAKE) d
	cd $(SRCDIR) && $(MAKE) z
	touch $@

Makefile.inc:../../config.status Makefile Makefile-mumps-$(VERSION).inc
	../../config.status --file="Makefile.inc:Makefile-mumps-$(VERSION).inc"

$(SRCDIR)/tag-tar:$(PACKAGE1)
	tar xvzf $(PACKAGE1)
	patch -d MUMPS_$(VERSION) -p 1 < MUMPS_$(VERSION).patch
	touch $(SRCDIR)/tag-tar

clean:clean-local
clean-local:
	-cd $(SRCDIR) &&  $(MAKE) clean -C $(SRCDIR) 
	-rm Makefile.inc FAIRE* ../lib/WHERE.mumps
	-rm -rf ../include/*mumps*
	-rm -rf ../lib/lib*mumps* ../lib/libpord*.a ../lib/libmpiseq*.a
	-rm -rf $(SRCDIR)
#	-rm $(PACKAGE1)
	-rm config.log *.done

# Local Variables:
# mode:makefile
# ispell-local-dictionary:"british"
# coding:utf-8
# End:

=== download/nlopt/Makefile ===
URL="http://ab-initio.mit.edu/nlopt/nlopt-2.2.4.tar.gz"
SRCDIR=nlopt-2.2.4
TARGZ=../pkg/$(SRCDIR).tar.gz
-include Make.defs

all: FAIRE

FAIRE: ../pkg $(SRCDIR)/FAIT 

$(SRCDIR)/FAIT: $(TARGZ)
	tar zxvf $(TARGZ)
#
#	FFCS - 30/11/11 - "--disable-dependency-tracking": dependencies pose problem on mixed Cygwin/MinGW setups
#	because of slashes and backslashes
#
# 	FFCS - 22/10/12 - Fred - "--without-octave": patch for one machine that has octave installed on it: building of
#	nlopt fails because it wants to install the octave components.  Not a bad idea in general but probably not when
#	building ffcs.
#
	cd $(SRCDIR) && ./configure --disable-dependency-tracking --with-cxx --prefix="$(FFDOWNLOAD)" CXX="$(CXX)"	\
	CXXFLAGS="$(CXXFLAGS)" CC="$(CC)" CFLAGS="$(CFLAGS)" CP="$(CXXCPP)" "--without-threadlocal" "--without-octave"
#
#	FFCS - 30/11/11 - we need to know when the building process breaks
#
	cd $(SRCDIR) && $(MAKE) install
	touch $(SRCDIR)/FAIT
	$(MAKE) WHERE
../pkg:
	mkdir $@

$(TARGZ):
	../getall -o NLopt -a

clean-local:
	rm -rf $(SRCDIR) Make.defs 
	rm -f ../lib/libnlopt_cxx*  ../lib/WHERE.nlopt 
	rm -f ../include/nlopt*

clean:clean-local

WHERE: 
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	echo nlopt LD -L@DIR@/lib -lnlopt_cxx  >../lib/WHERE.nlopt ;\
	echo nlopt INCLUDE -I@DIR@/include >> ../lib/WHERE.nlopt ;\
	fi

Make.defs: ../../config.status	Makefile Make.inc
	../../config.status  --file="Make.defs:Make.inc"

=== download/pastix/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
# 
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
# 
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

# Downloading and compiling extra libraries
# -----------------------------------------

include config.in

all-local: pastix

# Downloading and compiling pastix
# ------------------------------
DIRPKG   = ../pkg
SRCDIR   = pastix_release_$(VERSION)
PACKAGE1 = $(DIRPKG)/pastix_release_$(VERSION).tar.bz2
SERVER   = https://gforge.inria.fr/frs/download.php/21873/
INSTALL  = ../..
VERSION  = 2200

VERSIONTYPE=$(VERSIONINT)$(VERSIONPRC)$(VERSIONFLT)
VERSIONTYPECOMPLEX=$(VERSIONINT)_complex
VERSIONNAME=$(VERSIONBIT)$(VERSIONMPI)$(VERSIONSMP)$(VERSIONBUB)$(VERSIONTYPE)$(VERSIONORD)_$(HOSTARCH)
PASTIX_DIR = $(abs_top_builddir)/download/pastix/$(SRCDIR)/install

ifneq (,$(findstring libtool,$(ARPROG)))
	OBJLIBTOOL = $(SRCDIR)/src/sopalin/obj/$(HOSTARCH)/*.o $(SRCDIR)/src/blend/obj/$(HOSTARCH)/*.o $(SRCDIR)/src/fax/obj/$(HOSTARCH)/*.o $(SRCDIR)/src/kass/obj/$(HOSTARCH)/*.o $(SRCDIR)/src/order/obj/$(HOSTARCH)/*.o $(SRCDIR)/src/symbol/obj/$(HOSTARCH)/*.o $(SRCDIR)/src/common/obj/$(HOSTARCH)/*.o
else
	OBJLIBTOOL = 
endif

pastix: FAIRE


# FFCS - parallel make rules
WHERE: install
	echo double_pastix LD -L@DIR@/lib/pastix/double   -lpastix   >$(SRCDIR)/$(INSTALL)/lib/WHERE.pastix ;
	echo double_pastix INCLUDE -I@DIR@/include/pastix/double >> $(SRCDIR)/$(INSTALL)/lib/WHERE.pastix ;
	echo complex_pastix LD -L@DIR@/lib/pastix/complex   -lpastix   >>$(SRCDIR)/$(INSTALL)/lib/WHERE.pastix ;
	echo complex_pastix INCLUDE -I@DIR@/include/pastix/complex >> $(SRCDIR)/$(INSTALL)/lib/WHERE.pastix ;

FAIRE:$(SRCDIR)/FAIT 
	$(MAKE) WHERE
	touch FAIRE

config.in: ../Makefile ../../config.status	Makefile
	../../config.status  --file="config.in:config-pastix-real.in"
	../../config.status  --file="config-complex.in:config-pastix-complex.in"

install:$(SRCDIR)/FAIT

$(SRCDIR)/FAIT: $(SRCDIR) 
	cp config.in $(SRCDIR)/src/
#
#	FFCS - 16/1/13 - this crashes in parallel
#
	cd $(SRCDIR)/src; $(MAKE) -j1 expor
	#ifndef (,$(OBJLIBTOOL)) # redefinition of "cd $(SRCDIR)/src; $(MAKE) install" for libtool
	rm -f $(SRCDIR)/install/pastix*.h $(SRCDIR)/install/pastix*.in $(SRCDIR)/install/murge*.inc
	$(abs_top_builddir)/download/pastix/$(SRCDIR)/src/utils/bin/${HOSTARCH}/genheader $(PASTIX_DIR)/pastix$(VERSIONTYPE).h $(PASTIX_DIR)/pastix_fortran$(VERSIONTYPE).h \
	$(PASTIX_DIR)/murge$(VERSIONTYPE).inc $(SRCDIR)/src/murge/include/murge.h $(SRCDIR)/src/murge/scripts/genfort.pl
	cat $(SRCDIR)/src/../bin/$(HOSTARCH)/pastix.h         >> $(PASTIX_DIR)/pastix$(VERSIONTYPE).h
	cat $(SRCDIR)/src/common/src/api.h                    >> $(PASTIX_DIR)/pastix$(VERSIONTYPE).h
	cat $(SRCDIR)/src/../bin/$(HOSTARCH)/pastix_fortran.inc >> $(PASTIX_DIR)/murge$(VERSIONTYPE).inc
	ln -sf $(PASTIX_DIR)/pastix$(VERSIONTYPE).h         	$(PASTIX_DIR)/pastix.h
	ln -sf $(PASTIX_DIR)/pastix_fortran$(VERSIONTYPE).h 	$(PASTIX_DIR)/pastix_fortran.h
	ln -sf $(PASTIX_DIR)/murge$(VERSIONTYPE).inc	 	$(PASTIX_DIR)/murge.inc
	cp  $(SRCDIR)/src/sopalin/src/csc_utils.h                     $(PASTIX_DIR)/csc_utils$(VERSIONTYPE).h
	ln -fs $(PASTIX_DIR)/csc_utils$(VERSIONTYPE).h $(PASTIX_DIR)/csc_utils.h
	cp  $(SRCDIR)/src/sopalin/src/cscd_utils.h                    $(PASTIX_DIR)/cscd_utils${VERSIONTYPE}.h
	ln -fs $(PASTIX_DIR)/cscd_utils$(VERSIONTYPE).h $(PASTIX_DIR)/cscd_utils.h
	cp  $(SRCDIR)/src/common/src/nompi.h                          $(PASTIX_DIR)/pastix_nompi.h
	cp  $(SRCDIR)/src/murge/include/murge.h 			 $(PASTIX_DIR)/murge.h
	$(ARPROG) $(ARFLAGS) $(SRCDIR)/install/libpastix$(VERSIONNAME).a $(OBJLIBTOOL)
	ranlib $(SRCDIR)/install/libpastix$(VERSIONNAME).a
	ln -sf $(PASTIX_DIR)/libpastix$(VERSIONNAME).a $(PASTIX_DIR)/libpastix.a
	cp $(PASTIX_DIR)/../bin/$(HOSTARCH)/libpastix_murge.a $(PASTIX_DIR)/libpastix_murge$(VERSIONNAME).a
	ln -sf $(PASTIX_DIR)/libpastix_murge$(VERSIONNAME).a $(PASTIX_DIR)/libpastix_murge.a
	#else
	#cd $(SRCDIR)/src; $(MAKE) install
	#endif 
	mkdir -p $(SRCDIR)/$(INSTALL)/include/pastix/double
	cp $(SRCDIR)/install/*.h $(SRCDIR)/$(INSTALL)/include/pastix/double/
	mkdir -p $(SRCDIR)/$(INSTALL)/lib/pastix/double
	cp $(SRCDIR)/install/*.a $(SRCDIR)/$(INSTALL)/lib/pastix/double/
	cd $(SRCDIR)/src/ &&  $(MAKE) clean 
#
# complex version
#
	cp config-complex.in $(SRCDIR)/src/config.in	
#
#	FFCS - 16/1/13 - this crashes in parallel
#
	cd $(SRCDIR)/src/;$(MAKE) -j1 expor
#ifdef ($(OBJLIBTOOL))
	rm -f $(SRCDIR)/install/pastix*.h $(SRCDIR)/install/pastix*.in $(SRCDIR)/install/murge*.inc
	$(abs_top_builddir)/download/pastix/$(SRCDIR)/src/utils/bin/${HOSTARCH}/genheader $(PASTIX_DIR)/pastix$(VERSIONTYPECOMPLEX).h $(PASTIX_DIR)/pastix_fortran$(VERSIONTYPECOMPLEX).h \
	$(PASTIX_DIR)/murge$(VERSIONTYPECOMPLEX).inc $(SRDIR)/src/murge/include/murge.h $(SRDIR)/src/murge/scripts/genfort.pl
	cat $(SRCDIR)/src/../bin/$(HOSTARCH)/pastix.h         >> $(PASTIX_DIR)/pastix$(VERSIONTYPECOMPLEX).h
	cat $(SRCDIR)/src/common/src/api.h                    >> $(PASTIX_DIR)/pastix$(VERSIONTYPECOMPLEX).h
	cat $(SRCDIR)/src/../bin/$(HOSTARCH)/pastix_fortran.inc >> $(PASTIX_DIR)/murge$(VERSIONTYPECOMPLEX).inc
	ln -sf $(PASTIX_DIR)/pastix$(VERSIONTYPECOMPLEX).h         	$(PASTIX_DIR)/pastix.h
	ln -sf $(PASTIX_DIR)/pastix_fortran$(VERSIONTYPECOMPLEX).h 	$(PASTIX_DIR)/pastix_fortran.h
	ln -sf $(PASTIX_DIR)/murge$(VERSIONTYPECOMPLEX).inc	 	$(PASTIX_DIR)/murge.inc
	cp  $(SRCDIR)/src/sopalin/src/csc_utils.h                     $(PASTIX_DIR)/csc_utils$(VERSIONTYPECOMPLEX).h
	ln -fs $(PASTIX_DIR)/csc_utils$(VERSIONTYPECOMPLEX).h $(PASTIX_DIR)/csc_utils.h
	cp  $(SRCDIR)/src/sopalin/src/cscd_utils.h                    $(PASTIX_DIR)/cscd_utils${VERSIONTYPECOMPLEX}.h
	ln -fs $(PASTIX_DIR)/cscd_utils$(VERSIONTYPECOMPLEX).h $(PASTIX_DIR)/cscd_utils.h
	cp  $(SRCDIR)/src/common/src/nompi.h                          $(PASTIX_DIR)/pastix_nompi.h
	cp  $(SRCDIR)/src/murge/include/murge.h 			 $(PASTIX_DIR)/murge.h
	$(ARPROG) $(ARFLAGS) $(SRCDIR)/install/libpastix$(VERSIONNAME).a $(OBJLIBTOOL)
	ranlib $(SRCDIR)/install/libpastix$(VERSIONNAME).a
	ln -sf $(PASTIX_DIR)/libpastix$(VERSIONNAME).a $(PASTIX_DIR)/libpastix.a
	cp $(PASTIX_DIR)/../bin/$(HOSTARCH)/libpastix_murge.a $(PASTIX_DIR)/libpastix_murge$(VERSIONNAME).a
	ln -sf $(PASTIX_DIR)/libpastix_murge$(VERSIONNAME).a $(PASTIX_DIR)/libpastix_murge.a
#else
	#cd $(SRCDIR)/src/ && $(MAKE) install -C $(SRCDIR)/src
#endif
	mkdir -p $(SRCDIR)/$(INSTALL)/include/pastix/complex
	cp $(SRCDIR)/install/*.h $(SRCDIR)/$(INSTALL)/include/pastix/complex/
	mkdir -p $(SRCDIR)/$(INSTALL)/lib/pastix/complex
	cp $(SRCDIR)/install/*.a $(SRCDIR)/$(INSTALL)/lib/pastix/complex/
	(cd $(SRCDIR)/$(INSTALL)/include/pastix/complex/; patch pastix_long_complex.h)   <patch-pastix_long_complex.h
	(cd $(SRCDIR)/$(INSTALL)/include/pastix/complex/; patch pastix.h) <patch-pastix_long_complex.h
	touch $(SRCDIR)/FAIT



$(SRCDIR): $(PACKAGE1)
	tar xvfj $(PACKAGE1)
#
# 31/7/13 - ALH - patch from Fred to avoid picking up a locally installed version of Umfpack when FF compiles its own on
# Slackware64-14.0. For more information see FFCS comments from Fred on
# [[http://www.ljll.math.upmc.fr//~lehyaric/ffcs/news/20130528-1139.php]] (dated 30/7/13)
#
	patch -p0 < all_macros.diff
#
	cd $(SRCDIR)/src/blend/src/; patch -p2 < ../../../../pastix_release_2200-blend.patch
	touch $(SRCDIR)

$(PACKAGE1):
	../getall -o PaStiX -a

# FFCS: avoid loops when SRCDIR does not exist
clean-local:
	-cd $(SRCDIR)/src &&  $(MAKE) clean 

clean: clean-local
	-rm config.in FAIRE 
	-rm $(SRCDIR)/FAIT
	-rm -rf $(SRCDIR)/$(INSTALL)/include/pastix/double
	-rm -rf $(SRCDIR)/$(INSTALL)/lib/pastix/double
	-rm -rf $(SRCDIR)/$(INSTALL)/include/pastix/complex
	-rm -rf $(SRCDIR)/$(INSTALL)/lib/pastix/complex
	-rm -rf $(SRCDIR)
#
# FFCS - also force reconfiguration
#
	-rm config.in config-complex.in config.log
	-rm config.log
#	-rm $(PACKAGE1)

.PHONY:$(SRCDIR)/$(INSTALL)

# Local Variables:
# mode:makefile
# ispell-local-dictionary:"british"
# coding:utf-8
# End:

=== download/scotch/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
# 
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
# 
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.inc

all-local: scotch

# Downloading and compiling scotch
# -------------------------------
# http://gforge.inria.fr/frs/download.php/23391/scotch_5.1.7_esmumps.tar.gz
# Scotch information
DIRPKG=../pkg
SRCDIR=scotch_$(scotch_VERSION)
PACKAGE=$(DIRPKG)/scotch_$(scotch_VERSION_LOCAL).tar.gz
SERVER=https://gforge.inria.fr/frs/download.php/23391
INSTALL=../..
scotch_VERSION=5.1_esmumps
scotch_VERSION_LOCAL=5.1.6_esmumps
#  trick to no in MPI on NOT .. 
TESTMPI= test -n '$(CCP)'
scotch: FAIRE

$(SRCDIR)/AFAIRE:
	$(MAKE) install 

FAIRE: $(SRCDIR)/FAIT
	$(MAKE)  WHERE
	touch FAIRE
Makefile.inc: ../../config.status Makefile-scotch.inc Makefile
	../../config.status  --file="Makefile.inc:Makefile-scotch.inc"
	case `uname` in *CYGWIN*)  cp Makefile.inc Makefile.inn; sed "s/COPTIONS =/COPTIONS = -D__VC__/" <Makefile.inn > Makefile.inc; rm Makefile.inn ;; esac 
	case `uname` in *CYGWIN*|*MINGW*)  cp Makefile.inc Makefile.inn; sed -e "s/-DCOMMON_TIMING_OLD//" -e "s/-DCOMMON_RANDOM_FIXED_SEED/-DCOMMON_RANDOM_RAND  -DCOMMON_RANDOM_FIXED_SEED -D'pipe(pfds)=_pipe(pfds,1024,0x8000)'/" <Makefile.inn > Makefile.inc; rm Makefile.inn ;; esac 

# FFCS - 16/1/13 - what was "$(CCP)" used for?
$(SRCDIR)/FAIT: $(SRCDIR) Makefile.inc
	cp Makefile.inc $(SRCDIR)/src
	cd $(SRCDIR)/src && $(MAKE) scotch
#
#	FFCS - 16/1/13 - this crashes when run in parallel
#       FH: compile pt only if mpi is here 
	if $(TESTMPI) ; then  cd $(SRCDIR)/src && $(MAKE) -j1 ptscotch ; fi
	touch $(SRCDIR)/FAIT

install:$(SRCDIR)/FAIT
	mkdir -p $(SRCDIR)/$(INSTALL)/include/scotch
	cp $(SRCDIR)/include/*.h $(SRCDIR)/$(INSTALL)/include/scotch/
	cp $(SRCDIR)/lib/*.a $(SRCDIR)/$(INSTALL)/lib/

# ALH - 16/1/13 - simplifying make rules
WHERE:$(SRCDIR)/FAIT
	$(MAKE) install
	-rm $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	-$(TESTMPI) &&echo ptscotch LD -L@DIR@/lib -lptesmumps -lptscotch -lptscotcherr >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	-$(TESTMPI) &&echo ptscotch INCLUDE -I@DIR@/include/scotch >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo scotch LD -L@DIR@/lib -lscotch -lscotcherr >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo scotch INCLUDE -I@DIR@/include/scotch >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch

$(SRCDIR): $(PACKAGE)
	tar xvzf $(PACKAGE)
	cd $(SRCDIR)/src/libscotch/; patch -p1 < ../../../scotch_5.1_esmumps.patch
	cd $(SRCDIR)/src/esmumps/; patch -p1 < ../../../Makefile.patch
	touch $(SRCDIR)

$(PACKAGE):
	../getall -o Scotch -a

# FFCS - 28/3/13 - more cleaning
clean-local:
	-cd $(SRCDIR)/src && $(MAKE)  realclean  -C $(SRCDIR)/src
	-rm config.log
# FH 	-rm $(PACKAGE) 

clean: clean-local
	-rm Makefile.inc
	-rm -rf $(SRCDIR)
	-rm FAIRE 
.PHONY:$(SRCDIR)/$(INSTALL)

# Local Variables:
# mode:makefile
# ispell-local-dictionary:"british"
# coding:utf-8
# End:

=== download/superludist/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: superludist

# Downloading and compiling SuperLU DIST
# ------------------------------

# SUPERLU information
#http://crd.lbl.gov/~xiaoye/SuperLU/superlu_3.1.tar.gz
#http://crd-legacy.lbl.gov/~xiaoye/SuperLU/superlu_dist_3.0.tar.gz
DIRPKG=../pkg
SRCDIR=SuperLU_DIST_3.0
PACKAGE=superlu_dist_3.0.tar.gz
PACKAGE_PATH=$(DIRPKG)/$(PACKAGE)
SERVER=http://crd-legacy.lbl.gov/~xiaoye/SuperLU/
INSTALL=../..
SUPERLU_DIST_VERSION=3.0
DISTSUPERLULIB=../$(INSTALL)/lib/libsuperlu_dist_3.0.a
## WGET=wget

include make.inc

superludist: FAIT

# FFCS: more dependencies for parallel builds
FAIT:$(SRCDIR)
	$(MAKE) FAIRE install WHERE
	touch FAIT


FAIRE: $(SRCDIR)/SRC/$(DSUPERLULIB)  
	touch FAIRE

make.inc: ../../config.status  Makefile
	grep 'abs_top_builddir *=' ../Makefile >> dirflags
	cat dirflags make-superlu.inc > make-superlu-tmp.inc
	rm dirflags
	../../config.status  --file="make.inc:make-superlu-tmp.inc"
	case 'uname' in *CYGWIN_) cp make.inc Makefile.inn; sed "s/COPTIONS =/COPTIONS = -D__VC__/" <Makefile.inn > Makefile.in; rm Makefile.inn ;; esac
	rm make-superlu-tmp.inc

# FFCS: we need an error if make breaks
$(SRCDIR)/SRC/$(DSUPERLULIB): $(SRCDIR)
	cp make.inc $(SRCDIR)/make.inc
	cd $(SRCDIR)/SRC && $(MAKE)
# FFCS: we need more dependencies for parallel builds
install:$(SRCDIR)/SRC/$(DSUPERLULIB)
	mkdir -p $(SRCDIR)/$(INSTALL)/include/superludist
	cp $(SRCDIR)/SRC/*.h  $(SRCDIR)/$(INSTALL)/include/superludist
WHERE:
	echo superlu_dist LD -L@DIR@/lib -lsuperlu_dist_3.0  >$(SRCDIR)/$(INSTALL)/lib/WHERE.superlu_dist
	echo superlu_dist INCLUDE -I@DIR@/include/superludist  >> $(SRCDIR)/$(INSTALL)/lib/WHERE.superlu_dist


$(SRCDIR): $(PACKAGE_PATH)
	tar xvzf $(PACKAGE_PATH)
	cd $(SRCDIR)/SRC/; patch -p1 < ../../superludist_2.3.patch
	cd $(SRCDIR)/SRC/; patch -p3 < ../../superludist_3.0-printf.patch
	cd $(SRCDIR)/SRC/; patch -p2 < ../../superludist_3.0-cast_warning.patch
	cd $(SRCDIR)/SRC/; patch -p2 < ../../superludist_3.0-return_values.patch
	cd $(SRCDIR)/SRC/; patch -p2 < ../../superludist_3.0-operation_undefined.patch
	touch $(SRCDIR)

$(PACKAGE_PATH):
	../getall -o SuperLU_DIST -a

# FFCS - make sure that all directories are cleaned. Thisis especially important under Windows because there is no
# compilation dependencies control there (see [[file:c:/cygwin/home/alh/ffcs/dist/configure.ac::dependency_tracking]])

clean:
	-rm -rf SuperLU_DIST*
	-rm  ../include/superludist/*.h
	-rm -r ../include/superludist/
	-rm -r ../lib/libsuperlu_dist*.a
	-rm -r make.inc
	-rm -rf FAIT FAIRE

=== download/yams/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
all-local: yams

include ff-flags

# Downloading and compiling yams
# -------------------------------
# 
DIRPKG= ../pkg
SRCDIR= ./freeyams$(yams_VERSION)
#-$(yams_VERSION)
PACKAGE=$(DIRPKG)/freeyams$(yams_VERSION).tgz
SERVER=http://www.ann.jussieu.fr/~frey/ftp/archives/
INSTALL=../..
yams_VERSION=.2012.02.05

# ---------------------- 
#     yamslib

YAMS_DIR = $(abs_top_builddir)/download/yams/$(SRCDIR)
YAMS_SRCDIRNOLIB = $(YAMS_DIR)/sources
YAMS_SRCDIR = $(YAMS_DIR)/sourceslib
YAMS_OBJDIR = $(YAMS_DIR)/objects

yams: FAIRE  



# FFCS - make sure that PATCH is done sequentially otherwise its error messages are drowned into other meaningless
# parallel compilation messages

FAIRE: $(SRCDIR)/PATCH yamslib_internal.h yamslib.c yamslib.h  ../Makefile
	$(MAKE)  install  WHERE
	touch FAIRE

$(SRCDIR)/FAIT: $(SRCDIR)/PATCH  yamslib_internal.h yamslib.c yamslib.h 
	cp yamslib_internal.h yamslib.c yamslib.h $(YAMS_SRCDIR)/
	cp makefile-yams.inc $(YAMS_DIR)/makefile
	cd $(YAMS_DIR); make
	touch $(SRCDIR)/FAIT
install: $(SRCDIR)/FAIT
	sed  s/defines.h/freeyams_defines.h/ <$(YAMS_SRCDIR)/yamslib.h  >../include/freeyamslib.h
	cp $(YAMS_SRCDIR)/defines.h  ../include/freeyams_defines.h
	-mkdir ../lib	
	cp $(YAMS_OBJDIR)/libyams.a  ../lib/libfreeyams.a

# FFCS - WHERE is made to depend on FAIT otherwise it may be built in parallel and not be activated because FAIT is not
# there yet

WHERE: $(SRCDIR)/FAIT
	echo freeyams  LD -L@DIR@/lib -lfreeyams  >$(SRCDIR)/$(INSTALL)/lib/WHERE.freeyams ;
	echo freeyams INCLUDE -I@DIR@/include>> $(SRCDIR)/$(INSTALL)/lib/WHERE.freeyams ;

$(SRCDIR)/PATCH: $(PACKAGE) 
	-mkdir -p $(SRCDIR)
	cd $(SRCDIR); tar xvzf ../$(PACKAGE)
	-mkdir $(YAMS_SRCDIR)
	cp $(YAMS_SRCDIRNOLIB)/*.c $(YAMS_SRCDIRNOLIB)/*.h $(YAMS_SRCDIR)
	rm $(YAMS_SRCDIR)/memory.c 
	cp $(YAMS_SRCDIRNOLIB)/compil.date $(YAMS_SRCDIR)
	cd $(YAMS_SRCDIR) && \
	  patch -p2 < ../../freeyams$(yams_VERSION).patch && \
	  patch -p2 < ../../freeyams$(yams_VERSION)-return-values.patch
	mv  $(YAMS_SRCDIR)/yams.c $(YAMS_SRCDIR)/..
	touch $(SRCDIR)/PATCH

$(PACKAGE):
	../getall -o freeYams -a

# FFCS: only run make clean if cd to SRCDIR worked, otherwise this is infinite loop.

clean-local: 
	-rm FAIRE FAIT  $(SRCDIR)/FAIT
	-cd $(YAMS_DIR) &&  $(MAKE) -C $(YAMS_DIR)  clean
	-rm $(YAMS_OBJDIR)/libyams.a

# FFCS -simplifying all paths

 clean: clean-local
	-rm ff-flags
	-rm $(SRCDIR)/$(INSTALL)/lib/libfreeyams.a
	-rm $(SRCDIR)/$(INSTALL)/include/*freeyams*.h
	-rm $(SRCDIR)/$(INSTALL)/lib/WHERE.freeyams
	-rm ../lib/libfreeyams.a
	-rm ../include/*freeyams*.h
	-rm ../lib/WHERE.freeyams
	-rm -rf $(YAMS_DIR)
	-rm -rf $(SRCDIR)
	-rm $(PACKAGE)
	-rm FAIT FAIRE

ff-flags: ../Makefile Makefile
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'yams_VERSION *=' ./Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'LIBS *=' ../Makefile >> ff-flags


.PHONY: $(SRCDIR)/$(INSTALL)
